# Copyright 2019 Garmin Canada, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

'''
Python version of the constants from the antdefines.h header.
'''

ANT_STANDARD_DATA_PAYLOAD_SIZE = 8
ANT_EXT_MESG_DEVICE_ID_FIELD_SIZE = 4
ANT_EXT_STRING_SIZE = 27
ANT_EXT_MESG_BITFIELD_DEVICE_ID = 0x80
ANT_EXT_MESG_BIFIELD_EXTENSION = 0x01
ANT_EXT_MESG_BITFIELD_OVERWRITE_SHARED_ADR = 0x10
ANT_EXT_MESG_BITFIELD_TRANSMISSION_TYPE = 0x08
ANT_LIB_CONFIG_MASK_ALL = 0xFF
ANT_LIB_CONFIG_RADIO_CONFIG_ALWAYS = 0x01
ANT_LIB_CONFIG_MESG_OUT_INC_TIME_STAMP = 0x20
ANT_LIB_CONFIG_MESG_OUT_INC_RSSI = 0x40
ANT_LIB_CONFIG_MESG_OUT_INC_DEVICE_ID = 0x80
ANT_ID_SIZE = 4
ANT_ID_TRANS_TYPE_OFFSET = 3
ANT_ID_DEVICE_TYPE_OFFSET = 2
ANT_ID_DEVICE_NUMBER_HIGH_OFFSET = 1
ANT_ID_DEVICE_NUMBER_LOW_OFFSET = 0
ANT_ID_DEVICE_TYPE_PAIRING_FLAG = 0x80
ANT_TRANS_TYPE_SHARED_ADDR_MASK = 0x03
ANT_TRANS_TYPE_1_BYTE_SHARED_ADDRESS = 0x02
ANT_TRANS_TYPE_2_BYTE_SHARED_ADDRESS = 0x03
PARAMETER_RX_NOT_TX = 0x00
PARAMETER_TX_NOT_RX = 0x10
PARAMETER_SHARED_CHANNEL = 0x20
PARAMETER_NO_TX_GUARD_BAND = 0x40
PARAMETER_ALWAYS_RX_WILD_CARD_SEARCH_ID = 0x40
PARAMETER_RX_ONLY = 0x40
EXT_PARAM_ALWAYS_SEARCH = 0x01
EXT_PARAM_FREQUENCY_AGILITY = 0x04
RADIO_TX_POWER_LVL_MASK = 0x03
RADIO_TX_POWER_LVL_0 = 0x00
RADIO_TX_POWER_LVL_1 = 0x01
RADIO_TX_POWER_LVL_2 = 0x02
RADIO_TX_POWER_LVL_3 = 0x03
STATUS_CHANNEL_STATE_MASK = 0x03
STATUS_UNASSIGNED_CHANNEL = 0x00
STATUS_ASSIGNED_CHANNEL = 0x01
STATUS_SEARCHING_CHANNEL = 0x02
STATUS_TRACKING_CHANNEL = 0x03
CAPABILITIES_NO_RX_CHANNELS = 0x01
CAPABILITIES_NO_TX_CHANNELS = 0x02
CAPABILITIES_NO_RX_MESSAGES = 0x04
CAPABILITIES_NO_TX_MESSAGES = 0x08
CAPABILITIES_NO_ACKD_MESSAGES = 0x10
CAPABILITIES_NO_BURST_TRANSFER = 0x20
CAPABILITIES_OVERUN_UNDERRUN = 0x01
CAPABILITIES_NETWORK_ENABLED = 0x02
CAPABILITIES_AP1_VERSION_2 = 0x04
CAPABILITIES_SERIAL_NUMBER_ENABLED = 0x08
CAPABILITIES_PER_CHANNEL_TX_POWER_ENABLED = 0x10
CAPABILITIES_LOW_PRIORITY_SEARCH_ENABLED = 0x20
CAPABILITIES_SCRIPT_ENABLED = 0x40
CAPABILITIES_SEARCH_LIST_ENABLED = 0x80
CAPABILITIES_LED_ENABLED = 0x01
CAPABILITIES_EXT_MESSAGE_ENABLED = 0x02
CAPABILITIES_SCAN_MODE_ENABLED = 0x04
CAPABILITIES_RESERVED = 0x08
CAPABILITIES_PROX_SEARCH_ENABLED = 0x10
CAPABILITIES_EXT_ASSIGN_ENABLED = 0x20
CAPABILITIES_FS_ANTFS_ENABLED = 0x40
CAPABILITIES_FIT1_ENABLED = 0x80
CAPABILITIES_ADVANCED_BURST_ENABLED = 0x01
CAPABILITIES_EVENT_BUFFERING_ENABLED = 0x02
CAPABILITIES_EVENT_FILTERING_ENABLED = 0x04
CAPABILITIES_HIGH_DUTY_SEARCH_MODE_ENABLED = 0x08
CAPABILITIES_ACTIVE_SEARCH_SHARING_MODE_ENABLED = 0x10
CAPABILITIES_SELECTIVE_DATA_UPDATE_ENABLED = 0x40
CAPABILITIES_ENCRYPTED_CHANNEL_ENABLED = 0x80
CHANNEL_NUMBER_MASK = 0x1F
SEQUENCE_NUMBER_MASK = 0xE0
SEQUENCE_NUMBER_ROLLOVER = 0x60
SEQUENCE_FIRST_MESSAGE = 0x00
SEQUENCE_LAST_MESSAGE = 0x80
SEQUENCE_NUMBER_INC = 0x20
ADV_BURST_CONFIG_FREQ_HOP = 0x00000001
MSG_EXT_ID_MASK = 0xE0
BROADCAST_CONTROL_BYTE = 0x00
ACKNOWLEDGED_CONTROL_BYTE = 0xA0
RESPONSE_NO_ERROR = 0x00
NO_EVENT = 0x00
EVENT_RX_SEARCH_TIMEOUT = 0x01
EVENT_RX_FAIL = 0x02
EVENT_TX = 0x03
EVENT_TRANSFER_RX_FAILED = 0x04
EVENT_TRANSFER_TX_COMPLETED = 0x05
EVENT_TRANSFER_TX_FAILED = 0x06
EVENT_CHANNEL_CLOSED = 0x07
EVENT_RX_FAIL_GO_TO_SEARCH = 0x08
EVENT_CHANNEL_COLLISION = 0x09
EVENT_TRANSFER_TX_START = 0x0A
EVENT_CHANNEL_ACTIVE = 0x0F
EVENT_TRANSFER_TX_NEXT_MESSAGE = 0x11
CHANNEL_IN_WRONG_STATE = 0x15
CHANNEL_NOT_OPENED = 0x16
CHANNEL_ID_NOT_SET = 0x18
CLOSE_ALL_CHANNELS = 0x19
TRANSFER_IN_PROGRESS = 0x1F
TRANSFER_SEQUENCE_NUMBER_ERROR = 0x20
TRANSFER_IN_ERROR = 0x21
TRANSFER_BUSY = 0x22
INVALID_MESSAGE_CRC = 0x26
MESSAGE_SIZE_EXCEEDS_LIMIT = 0x27
INVALID_MESSAGE = 0x28
INVALID_NETWORK_NUMBER = 0x29
INVALID_LIST_ID = 0x30
INVALID_SCAN_TX_CHANNEL = 0x31
INVALID_PARAMETER_PROVIDED = 0x33
EVENT_SERIAL_QUE_OVERFLOW = 0x34
EVENT_QUE_OVERFLOW = 0x35
EVENT_CLK_ERROR = 0x36
EVENT_STATE_OVERRUN = 0x37
EVENT_ENCRYPT_NEGOTIATION_SUCCESS = 0x38
EVENT_ENCRYPT_NEGOTIATION_FAIL = 0x39
SCRIPT_FULL_ERROR = 0x40
SCRIPT_WRITE_ERROR = 0x41
SCRIPT_INVALID_PAGE_ERROR = 0x42
SCRIPT_LOCKED_ERROR = 0x43
NO_RESPONSE_MESSAGE = 0x50
RETURN_TO_MFG = 0x51
FIT_ACTIVE_SEARCH_TIMEOUT = 0x60
FIT_WATCH_PAIR = 0x61
FIT_WATCH_UNPAIR = 0x62
USB_STRING_WRITE_FAIL = 0x70
INTERNAL_ONLY_EVENTS = 0x80
EVENT_RX = 0x80
EVENT_NEW_CHANNEL = 0x81
EVENT_PASS_THRU = 0x82
EVENT_BLOCKED = 0xFF
SCRIPT_CMD_FORMAT = 0x00
SCRIPT_CMD_DUMP = 0x01
SCRIPT_CMD_SET_DEFAULT_SECTOR = 0x02
SCRIPT_CMD_END_SECTOR = 0x03
SCRIPT_CMD_END_DUMP = 0x04
SCRIPT_CMD_LOCK = 0x05
USB_DESCRIPTOR_VID_PID = 0x00
USB_DESCRIPTOR_MANUFACTURER_STRING = 0x01
USB_DESCRIPTOR_DEVICE_STRING = 0x02
USB_DESCRIPTOR_SERIAL_STRING = 0x03
RESET_FLAGS_MASK = 0xE0
RESET_SUSPEND = 0x80
RESET_SYNC = 0x40
RESET_CMD = 0x20
RESET_WDT = 0x02
RESET_RST = 0x01
RESET_POR = 0x00
EVENT_RX_BROADCAST = 0x9A
EVENT_RX_ACKNOWLEDGED = 0x9B
EVENT_RX_BURST_PACKET = 0x9C
EVENT_RX_EXT_BROADCAST = 0x9D
EVENT_RX_EXT_ACKNOWLEDGED = 0x9E
EVENT_RX_EXT_BURST_PACKET = 0x9F
EVENT_RX_RSSI_BROADCAST = 0xA0
EVENT_RX_RSSI_ACKNOWLEDGED = 0xA1
EVENT_RX_RSSI_BURST_PACKET = 0xA2
EVENT_RX_FLAG_BROADCAST = 0xA3
EVENT_RX_FLAG_ACKNOWLEDGED = 0xA4
EVENT_RX_FLAG_BURST_PACKET = 0xA5
MESG_FS_ANTFS_EVENT_PAIR_REQUEST = 0x01
MESG_FS_ANTFS_EVENT_DOWNLOAD_START = 0x02
MESG_FS_ANTFS_EVENT_UPLOAD_START = 0x03
MESG_FS_ANTFS_EVENT_DOWNLOAD_COMPLETE = 0x04
MESG_FS_ANTFS_EVENT_UPLOAD_COMPLETE = 0x05
MESG_FS_ANTFS_EVENT_ERASE_COMPLETE = 0x06
MESG_FS_ANTFS_EVENT_LINK_STATE = 0x07
MESG_FS_ANTFS_EVENT_AUTH_STATE = 0x08
MESG_FS_ANTFS_EVENT_TRANSPORT_STATE = 0x09
MESG_FS_ANTFS_EVENT_CMD_RECEIVED = 0x0A
MESG_FS_ANTFS_EVENT_CMD_PROCESSED = 0x0B
FS_NO_ERROR_RESPONSE = 0x00
FS_MEMORY_UNFORMATTED_ERROR_RESPONSE = 0x01
FS_MEMORY_NO_FREE_SECTORS_ERROR_RESPONSE = 0x02
FS_MEMORY_READ_ERROR_RESPONSE = 0x03
FS_MEMORY_WRITE_ERROR_RESPONSE = 0x04
FS_MEMORY_ERASE_ERROR_RESPONSE = 0x05
FS_TOO_MANY_FILES_OPEN_RESPONSE = 0x06
FS_FILE_INDEX_INVALID_ERROR_RESPONSE = 0x07
FS_FILE_INDEX_EXISTS_ERROR_RESPONSE = 0x08
FS_AUTO_INDEX_FAILED_TRY_AGAIN_ERROR_RESPONSE = 0x09
FS_FILE_ALREADY_OPEN_ERROR_RESPONSE = 0x0A
FS_FILE_NOT_OPEN_ERROR_RESPONSE = 0x0B
FS_DIR_CORRUPTED_ERROR_RESPONSE = 0x0C
FS_INVALID_OFFSET_ERROR_RESPONSE = 0x0D
FS_BAD_PERMISSIONS_ERROR_RESPONSE = 0x0E
FS_EOF_REACHED_ERROR_RESPONSE = 0x0F
FS_INVALID_FILE_HANDLE_ERROR_RESPONSE = 0x10
FS_CRYPTO_OPEN_PERMISSION_ERROR_RESPONSE = 0x32
FS_CRYPTO_HANDLE_ALREADY_IN_USE_RESPONSE = 0x33
FS_CRYPTO_USER_KEY_NOT_SPECIFIED_RESPONSE = 0x34
FS_CRYPTO_USER_KEY_ADD_ERROR_RESPONSE = 0x35
FS_CRYPTO_USER_KEY_FETCH_ERROR_RESPONSE = 0x36
FS_CRYPTO_IVNONE_READ_ERROR_RESPONSE = 0x37
FS_CRYPTO_BLOCK_OFFSET_ERROR_RESPONSE = 0x38
FS_CRYPTO_BLOCK_SIZE_ERROR_RESPONSE = 0x39
FS_CRYPTO_CFG_TYPE_NOT_SUPPORTED_RESPONSE = 0x40
FS_FIT_FILE_HEADER_ERROR_RESPONSE = 0x64
FS_FIT_FILE_SIZE_INTEGRITY_ERROR_RESPONSE = 0x65
FS_FIT_FILE_CRC_ERROR_RESPONSE = 0x66
FS_FIT_FILE_CHECK_PERMISSION_ERROR_RESPONSE = 0x67
FS_FIT_FILE_CHECK_FILE_TYPE_ERROR_RESPONSE = 0x68
FS_FIT_FILE_OP_ABORT_ERROR_RESPONSE = 0x69

CAPABILITIES_MAX_CHANNELS_INDEX = 0x00
CAPABILITIES_MAX_NETWORKS_INDEX = 0x01
CAPABILITIES_STANDARD_OPTIONS_INDEX = 0x02
CAPABILITIES_ADVANCED_OPTIONS_INDEX = 0x03
CAPABILITIES_ADVANCED_OPTIONS2_INDEX = 0x04
CAPABILITIES_SENSORCORE_CHANNELS_INDEX = 0x05
CAPABILITIES_ADVANCED_OPTIONS3_INDEX = 0x06
CAPABILITIES_ADVANCED_OPTIONS4_INDEX = 0x07

# Channel Types
CHANNEL_TYPE_SLAVE = (PARAMETER_RX_NOT_TX)
CHANNEL_TYPE_MASTER = (PARAMETER_TX_NOT_RX)
CHANNEL_TYPE_SHARED_SLAVE = (PARAMETER_RX_NOT_TX | PARAMETER_SHARED_CHANNEL)
CHANNEL_TYPE_SHARED_MASTER = (PARAMETER_TX_NOT_RX | PARAMETER_SHARED_CHANNEL)
CHANNEL_TYPE_SLAVE_RX_ONLY = (PARAMETER_RX_NOT_TX | PARAMETER_RX_ONLY)
CHANNEL_TYPE_MASTER_TX_ONLY = (PARAMETER_TX_NOT_RX | PARAMETER_NO_TX_GUARD_BAND)
